import React from 'react';
import Avatar from '@mui/material/Avatar';

import { backURL, stringColor }  from '../helpers'
import { connect }  from 'react-redux'

const small = {
  height: '40px', 
  width: '40px'
}
const middle = {
  height: '50px', 
  width: '50px'
}
const big = {
  height: '80px', 
  width: '80px'
}


function getUrl(obj) {
  if (obj.localUrl) {
    return obj.localUrl
  } else if (obj.avatar?.url) {
    return backURL + obj.avatar?.url
  } else {
    return false
  }
}

export const UserAvatar = ({  profile, bigSize=false }) => {
  return (
    <>
    {
        getUrl(profile) ?
        <Avatar  sx={ bigSize ? big : small } 
                alt={profile.nick || profile.login } src={getUrl(profile)} /> :
        <Avatar  sx={ bigSize ? big : small }
                {...stringColor.stringAvatar(profile.nick || profile.login)} /> 
    }        
    </>
  ) 
}
export const CMyAvatar = connect( state => ({ profile: state.promise.myProfile?.payload || {} }))(UserAvatar)


export const ChatAvatar = ({ chat, bigSize=false }) => {
  return (
    <>
    {
        getUrl(chat) ?
        <Avatar  sx={ bigSize ? big : small } 
                alt={chat.title } src={getUrl(chat)} /> :
        <Avatar  sx={ bigSize ? big : small }
                {...stringColor.stringAvatar(chat.title)} /> 
    }        
    </>
  ) 
}

