

export const decorateLinks = (text, style) => {

   const linkRegEx = /https?:\/\/(www\.)?[-a-zA-Z0-9@:%._\+~#=]{1,256}\.[a-zA-Z0-9()]{1,6}\b([-a-zA-Z0-9()@:%_\+.~#?&//=]*)/
   const youtubeRegEx = /http(?:s?):\/\/(?:www\.)?youtu(?:be\.com\/watch\?v=|\.be\/)([\w\-\_]*)(&(amp;)?‌​[\w\?‌​=]*)?/

   let matchLink = text.match(linkRegEx)
   let matchYoutube = text.match(youtubeRegEx)

   if (matchLink) {
       let [link] = matchLink
       if (link) {
           let newLink = <a href={link} style="color:blue">{link}</a>
           let newText = null
           newText = text.replace(link, newLink)
           if (matchYoutube) {
               let [, youtubeKey] = matchYoutube
   
               if (youtubeKey) {
                   return (
                     <>
                        <pre>{newText}</pre> <br/> <iframe width="560" height="315" 
                        src="https://www.youtube.com/embed/${youtubeKey}" title="YouTube video player" 
                        frameborder="0" allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; 
                        picture-in-picture" allowfullscreen></iframe>
                     </>
                   )

               } 
           } else {
               return (
                  <pre>{newText}</pre>
               ) 
           }
       }

   } else {
       return (
         <pre>{text}</pre>
       ) 
   }
}