import React, { useState } from 'react'
import Box from '@mui/material/Box';

import {
   MenuDrawer, 
   SearchBlock, 
   Header, 
   FloatBtn, 
   CChatModal
} from "../components"

const asidePageContainer = {
   height: "100vh",
   maxWidth: "100%",
   position: 'relative',
   zIndex: 2,
}
const asidePageHeader = {
   height: "60px"
}

const FloatBtnModal = ({ OPEN }) => {
   return (
     <Box onClick={OPEN}
       sx={{  position: 'absolute', top: '90%', left: '65%', zIndex: 10 }} >
       <FloatBtn />
     </Box>
   )
 }
 

export const AsidePage = ({children}) => {

   const [input, setInput] = useState('')

   return (
      <div style={asidePageContainer}>

         <div style={asidePageHeader}>
            <Header>
               <MenuDrawer />
               <SearchBlock setInput={setInput} />
            </Header>  
         </div>

         {children}

         <CChatModal key={'creation'} create={true} render={FloatBtnModal} />

      </div>
   )
}
