import React, {useState, useEffect, useRef} from 'react';

import {
   Header, 
   CChatMngHeader,
   CMsgList,
   CSendingField,   
} from "../components"
import {
   PageNoChat  
} from "."

import {
   actionFullMsgsByChat,
 } from "../actions"
 import {
   actionChatOne
 } from "../reducers"
 import { connect } from 'react-redux'
import { Repeat } from '@mui/icons-material';



const msgPageContainer = {
   backgroundColor: '#eee',
   height: "100vh",
   width: "100%"
}
const msgPageHeader = {
   height: "60px"
}
const msgPageBody = {
   height: "calc(100vh - 60px)",
   display: "flex",
   flexDirection: "column",
   justifyContent: "space-between"
}

const msgs = {
   flexGrow: 1,
   overflowY: "auto",
   display: "flex",
   flexDirection: "column-reverse",
}
const msgSend = {
   flexGrow: 0,
   height: "max-content",
   maxHeight: "60%",
}


 

const MsgBlock = ({ chatId, getMsgs, setLastVizited, msgsCount=20 }) => {

   const [msgToEdit, setmMsgToEdit] = useState()

   const [msgsBlock, setMsgsBlock] = useState(0)

   
   const divRef = useRef(null)


   useEffect( () => {
      console.log(chatId)
      getMsgs(chatId, msgsBlock, msgsCount)
   },[msgsBlock])


   useEffect(() => {
      // console.log(chatId, "МАУНТ СООБЩЕНИЙ")
      const date = (new Date()).getTime()
      setLastVizited({
            _id: chatId, 
            lastVizited: date,
         }
      ) 

      return () => {
         // console.log(chatId, "АНМАУНТ СООБЩЕНИЙ")
         const date = (new Date()).getTime()
         setLastVizited({
               _id: chatId, 
               lastVizited: date,
            }
         )  
      }
   }, [chatId])

   // lastVizited: (Math.ceil((new Date()).getTime()/1000).toString(16) + '0'.repeat(16) )

   return (
      <>  
         <div style={msgPageContainer}>

            <div style={msgPageHeader}>
               <Header> 

                  <CChatMngHeader chatId={chatId} />

               </Header>  
            </div>

            <div style={msgPageBody}>

               <div 
                  style={msgs}
                  ref={divRef}
                  onScroll={(e) => {

                     if (e.target.scrollTop*(-1) >= e.target.scrollHeight - e.target.clientHeight) {
                        setMsgsBlock(msgsBlock => msgsBlock + msgsCount)
                     }
                  }}
                  >
                  <CMsgList chatId={chatId} onEdit={setmMsgToEdit} />
               </div>

               <div style={msgSend}>
                  <CSendingField chatId={chatId} msg={msgToEdit} />
               </div>       

            </div>

         </div>              
      </>
   )
}
const CMsgBlock = connect( null, {getMsgs: actionFullMsgsByChat, setLastVizited: actionChatOne })(MsgBlock)


const MsgPage = ({ match:{params:{_id}}, chats }) => {

   if (_id in chats) {
      return (
         <CMsgBlock chatId={_id} key={_id} />
      )
   } else {
      return (
         <PageNoChat />
      )
   }

}
export const CMsgPage = connect( state => ({ chats: state.chats }) )(MsgPage)

