


export const localStoredReducer = (reducer, localStorageName) => (
    (state, action) => {
        // console.log(state, action)

        if (!state && localStorage[localStorageName]) {
            return JSON.parse(localStorage[localStorageName])
        } else {
            let newState = reducer(state, action)
            setTimeout(() => localStorage.setItem(localStorageName, JSON.stringify(newState)))
            
            return newState
        }
    }
)